from smc import getRobotFromArgs
from smc import getMinimalArgParser
from smc.control.optimal_control.util import get_OCP_args
from smc.control.cartesian_space import getClikArgs
from smc.control.optimal_control.croco_mpc_path_following import (
    CrocoEEPathFollowingMPC,
)
import numpy as np


def path(T_w_e, i):
    # 2) do T_mobile_base_ee_pos to get
    # end-effector reference frame(s)

    # generate bullshit just to see it works
    path = []
    t = i * robot.dt
    for i in range(args.n_knots):
        t += 0.01
        new = T_w_e.copy()
        translation = 2 * np.array([np.cos(t / 20), np.sin(t / 20), 0.3])
        new.translation = translation
        path.append(new)
    return path


def get_args():
    parser = getMinimalArgParser()
    parser = get_OCP_args(parser)
    parser = getClikArgs(parser)  # literally just for goal error
    args = parser.parse_args()
    return args


if __name__ == "__main__":
    args = get_args()
    robot = getRobotFromArgs(args)
    x0 = np.concatenate([robot.q, robot.v])
    robot._step()

    CrocoDualEEPathFollowingMPC(args, robot, x0, path)

    print("final position:", robot.T_w_e)

    if args.real:
        robot.stopRobot()

    if args.save_log:
        robot._log_manager.saveLog()
        robot._log_manager.plotAllControlLoops()

    if args.visualizer:
        robot.killManipulatorVisualizer()
