from smc import getMinimalArgParser, getRobotFromArgs
from smc.util.define_random_goal import getRandomlyGeneratedGoal
from smc.control.cartesian_space import getClikArgs
from smc.robots.utils import defineGoalPointCLI
from smc.control.cartesian_space.cartesian_space_point_to_point import moveL

import numpy as np
import argparse


def get_args():
    parser = getMinimalArgParser()
    parser.description = "Run closed loop inverse kinematics \
    of various kinds. Make sure you know what the goal is before you run!"
    parser = getClikArgs(parser)
    parser.add_argument(
        "--randomly-generate-goal",
        action=argparse.BooleanOptionalAction,
        default=False,
        help="if true, rand generate a goal, if false you type it in via text input",
    )
    args = parser.parse_args()
    return args


if __name__ == "__main__":
    args = get_args()
    robot = getRobotFromArgs(args)
    if args.randomly_generate_goal:
        Mgoal = getRandomlyGeneratedGoal(args)
        if args.visualizer:
            robot.visualizer_manager.sendCommand({"Mgoal": Mgoal})
    else:
        Mgoal = defineGoalPointCLI(robot)
        Mgoal.rotation = np.eye(3)
    # compliantMoveL(args, robot, Mgoal)
    if robot.robot_name != "yumi":
        moveL(args, robot, Mgoal)
    #    else:
    #        goal_transform = pin.SE3.Identity()
    #        goal_transform.translation[1] = 0.1
    #        moveLDualArm(args, robot, Mgoal, goal_transform)
    robot.closeGripper()
    robot.openGripper()
    if args.real:
        robot.stopRobot()

    if args.visualizer:
        robot.killManipulatorVisualizer()

    if args.save_log:
        robot._log_manager.saveLog()
    # loop_manager.stopHandler(None, None)
