#!/bin/bash
# the idea here is to run all the runnable things
# and test for syntax errors 
#
# ################
# single arm 
# ###############
# damped pseudoinverse
runnable="clik_point_to_point.py --randomly-generate-goal --ctrl-freq=-1 --no-plotter --no-visualizer --max-iterations=2000"
echo $runnable
python $runnable

# QP quadprog
runnable="clik_point_to_point.py --randomly-generate-goal --ik-solver=QPquadprog --ctrl-freq=-1 --no-visualizer --no-plotter --max-iterations=2000"
echo $runnable
python $runnable

# QP proxsuite
runnable="clik_point_to_point.py --randomly-generate-goal --ik-solver=QPproxsuite --ctrl-freq=-1 --no-visualizer --no-plotter --max-iterations=2000"
echo $runnable
python $runnable

######################
# whole body single arm
######################
# damped pseudoinverse 
runnable="clik_point_to_point.py --robot=heron --randomly-generate-goal --ctrl-freq=-1 --no-visualizer --no-plotter --max-iterations=2000"
echo $runnable
python $runnable

# QP quadprog
runnable="clik_point_to_point.py --robot=heron --randomly-generate-goal --ik-solver=QPquadprog --ctrl-freq=-1 --no-visualizer --no-plotter --max-iterations=2000"
echo $runnable
python $runnable

# QP proxsuite
runnable="clik_point_to_point.py --robot=heron --randomly-generate-goal --ik-solver=QPproxsuite --ctrl-freq=-1 --no-visualizer --no-plotter --max-iterations=2000"
echo $runnable
python $runnable

######################
# dual arm
# ####################
# damped pseudoinverse
runnable="dual_arm_clik.py --robot=yumi --randomly-generate-goal  --ctrl-freq=-1 --no-visualizer --no-plotter --max-iterations=2000"
echo $runnable
python $runnable

# QP quadprog
runnable="dual_arm_clik.py --robot=yumi --randomly-generate-goal --ik-solver=QPquadprog --ctrl-freq=-1 --no-visualizer --no-plotter --max-iterations=2000"
echo $runnable
python $runnable

# QP proxsuite
runnable="dual_arm_clik.py --robot=yumi --randomly-generate-goal --ik-solver=QPproxsuite --ctrl-freq=-1 --no-visualizer --no-plotter --max-iterations=2000"
echo $runnable
python $runnable

# ##########################
# whole body dual arm
# ##########################
# damped pseudoinverse 
runnable="dual_arm_clik.py --robot=myumi --randomly-generate-goal  --ctrl-freq=-1 --no-visualizer --no-plotter --max-iterations=2000"
echo $runnable
python $runnable

# QP quadprog
runnable="dual_arm_clik.py --robot=myumi --randomly-generate-goal --ik-solver=QPquadprog --ctrl-freq=-1 --no-visualizer --no-plotter --max-iterations=2000"
echo $runnable
python $runnable

# QP proxsuite
runnable="dual_arm_clik.py --robot=myumi --randomly-generate-goal --ik-solver=QPproxsuite --ctrl-freq=-1 --no-visualizer --no-plotter --max-iterations=2000"
echo $runnable
python $runnable
