from smc import getRobotFromArgs
from smc.robots.interfaces.whole_body_interface import SingleArmWholeBodyInterface
from smc import getMinimalArgParser
from smc.path_generation.maps.premade_maps import createSampleStaticMap
from smc.path_generation.path_math.path2d_to_6d import path2D_to_SE3
from smc.control.optimal_control.util import get_OCP_args
from smc.control.cartesian_space import getClikArgs
from smc.path_generation.planner import starPlanner, getPlanningArgs
from smc.control.optimal_control.croco_mpc_path_following import (
    CrocoBasePathFollowingMPC,
)
from smc.multiprocessing import ProcessManager

import time
import numpy as np
from functools import partial
import pinocchio as pin


def get_args():
    parser = getMinimalArgParser()
    parser = get_OCP_args(parser)
    parser = getClikArgs(parser)  # literally just for goal error
    parser = getPlanningArgs(parser)
    args = parser.parse_args()
    return args


# DA BI OVAJ MPC SEX FUNKCIONIRAO, MORAS MU DAT PIN.MODEL SAMO BAZE!!!
# ili to il ce se vrtit GRO sporo bez razloga

if __name__ == "__main__":
    args = get_args()
    robot = getRobotFromArgs(args)
    # TODO: for ocp you want to pass only the mobile base model
    # robot._mode = SingleArmWholeBodyInterface.control_mode.base_only
    robot._step()
    robot._q[0] = 9.0
    robot._q[1] = 4.0
    robot._step()
    x0 = np.concatenate([robot.q, robot.v])
    goal = np.array([0.5, 5.5])
    T_w_b = robot.T_w_b

    planning_function = partial(starPlanner, goal)
    # here we're following T_w_e reference so that's what we send
    path_planner = ProcessManager(
        args, planning_function, T_w_b.translation[:2], 3, None
    )
    _, map_as_list = createSampleStaticMap()
    if args.visualizer:
        robot.sendRectangular2DMapToVisualizer(map_as_list)
        # time.sleep(5)

    CrocoBasePathFollowingMPC(args, robot, x0, path_planner)

    print("final position:", robot.T_w_b.translation)

    if args.real:
        robot.stopRobot()

    if args.save_log:
        robot._log_manager.saveLog()
        robot._log_manager.plotAllControlLoops()

    if args.visualizer:
        robot.killManipulatorVisualizer()
