from smc import getMinimalArgParser, getRobotFromArgs
from smc.control.optimal_control.croco_mpc_point_to_point import (
    CrocoEEP2PMPC,
)
from smc.control.optimal_control.util import get_OCP_args
from smc.control.cartesian_space import getClikArgs
import pinocchio as pin
import argcomplete


def get_args():
    parser = getMinimalArgParser()
    parser = get_OCP_args(parser)
    parser = getClikArgs(parser)  # literally just for goal error
    argcomplete.autocomplete(parser)
    args = parser.parse_args()
    return args


if __name__ == "__main__":
    args = get_args()
    robot = getRobotFromArgs(args)
    # TODO: put this back for nicer demos
    # Mgoal = defineGoalPointCLI()
    T_w_goal = pin.SE3.Random()

    if args.visualizer:
        # TODO: document this somewhere
        robot.visualizer_manager.sendCommand({"Mgoal": T_w_goal})

    CrocoEEP2PMPC(args, robot, T_w_goal)

    print("final position:")
    print(robot.T_w_e)

    if args.real:
        robot.stopRobot()

    if args.visualizer:
        robot.killManipulatorVisualizer()

    if args.save_log:
        robot._log_manager.saveLog()
        robot._log_manager.plotAllControlLoops()
