#!/bin/bash
# the idea here is to run all the runnable things
# and test for syntax errors 
#
# ################
# single arm 
# ###############
# ocp
runnable="croco_ik_ocp.py --ctrl-freq=-1 --no-plotter --no-visualizer --max-iterations=2000"
echo $runnable
python $runnable

# mpc
runnable="croco_ik_mpc.py --max-solver-iter 10 --n-knots 30  --ctrl-freq=-1 --no-visualizer --no-plotter --max-iterations=2000"
echo $runnable
python $runnable

######################
# whole body single arm
######################
# ocp
runnable="croco_ik_ocp.py --robot=heron --ctrl-freq=-1 --no-visualizer --no-plotter --max-iterations=2000"
echo $runnable
python $runnable
# mpc
runnable="croco_ik_mpc.py --max-solver-iter 10 --n-knots 30 --robot=heron --ctrl-freq=-1 --no-visualizer --no-plotter --max-iterations=2000"
echo $runnable
python $runnable

######################
# dual arm
# ####################
# ocp TODO: missing

# mpc
runnable="dual_arm_ik_mpc.py --max-solver-iter 10 --n-knots 30 --robot=yumi --ctrl-freq=-1 --no-visualizer --no-plotter --max-iterations=2000"
echo $runnable
python $runnable

# ##########################
# whole body dual arm
# ##########################
# ocp TODO: missing
#
# mpc
runnable="dual_arm_ik_mpc.py --max-solver-iter 10 --n-knots 30 --robot=myumi --ctrl-freq=-1 --no-visualizer --no-plotter --max-iterations=2000"
echo $runnable
python $runnable

##############################
# base only
# ##################################
# ocp TODO: missing
# mpc TODO: missing

##############################
# whole body single arm base + ee reference
# ##################################
# ocp TODO: missing
# mpc TODO: missing
#
##############################
# whole body dual arm base + ee reference
# ##################################
# ocp TODO: missing
# mpc TODO: missing
